IMPLEMENTATION MODULE ArgHandler;
(*$ LargeVars:=FALSE LongAlign:=FALSE StackChk:=FALSE StackParms:=FALSE
    NilChk:=FALSE Volatile:=FALSE RangeChk:=FALSE OverflowChk:=FALSE *)

FROM SYSTEM	IMPORT	ADDRESS,ADR,SETREG,ASSEMBLE,CAST;
FROM AMScan	IMPORT	ScanString;
FROM Arguments	IMPORT	NumArgs, GetArg, GetLock;
FROM String	IMPORT	Copy,FirstPos,Length;

(*FROM String	IMPORT	Insert;*)
FROM Arts	IMPORT	Assert,thisTask,returnVal,dosCmdBuf,StrPtr,Terminate,
			wbStarted;
FROM Terminal	IMPORT	WriteString, Flush, FormatS, ReadLn;
IMPORT ASCII,DosD,DosL;

VAR
  Args,ActArg:INTEGER;
  OptProc: OptionProc;
  inMsg: POINTER TO ARRAY[0..79] OF CHAR;
  OptFile,SecFile: ADDRESS;
  startCD,myRealCD:DosD.FileLockPtr;
  replyVal:LONGINT;

(* p wird aufgerufen, wenn ein String mit '+' oder '-' oder '?' beginnt. *)
PROCEDURE InitHandler(p:OptionProc; msg,firstName,secName:ADDRESS);
BEGIN
  OptProc:=p;
  inMsg:=msg;
  OptFile:=firstName;
  SecFile:=secName;
  IF ~wbStarted & (CAST(StrPtr,dosCmdBuf)^[0]="?") THEN
    IF OptProc("?",1) THEN END;
    Terminate;
  END;
END InitHandler;

PROCEDURE SetReply(val{0}:LONGINT);
BEGIN
  IF val>replyVal THEN replyVal:=val END;
  IF val>returnVal THEN returnVal:=val END;
END SetReply;


VAR
 scanReadPos,len:INTEGER;

CONST MaxStrLen=255;
TYPE StringStatus=(fileStr,secStr,argStr,interStr);
VAR stStat: StringStatus;
VAR buffer:ARRAY[0..MaxStrLen] OF CHAR;

(* liest in buffer[] *)
(* wenn ~interActive, dann nix lesen! *)
PROCEDURE NextLine;
VAR gotFile:BOOLEAN; ch:CHAR; f:DosD.FileHandlePtr; len,high:INTEGER;
    ptr:POINTER TO CHAR;
BEGIN
  myCD:=myRealCD;
  len:=0; buffer[0]:=0C;
  high:=MaxStrLen;
  REPEAT
    IF stStat<=secStr THEN
      f:=DosL.Open(OptFile,DosD.readOnly);
      IF f#NIL THEN
        len:=0;
        WHILE (len<high)
	     &(DosL.Read(f,ADR(ch),1)>0) (* =1 *)
	     &(ch#ASCII.eol)
	     &(ch#ASCII.eof) DO
	  buffer[len]:=ch; INC(len);
        END;
        buffer[len]:=ASCII.nul;
        DosL.Close(f);
      END;
      INC(stStat); (* args dranhngen! *)
      OptFile:=SecFile;
    END;
  UNTIL (stStat>secStr) OR (len>0);
  IF (len=0)&(stStat=argStr) THEN
    INC(ActArg);
    IF ActArg<=Args THEN
      GetArg(ActArg,buffer,len); (* Weil GetArg CD verndert! *)
      myCD:=GetLock(ActArg);
      IF myCD=NIL THEN myCD:=myRealCD END;
    ELSE
      INC(stStat);
    END;
  END;
  IF (stStat=interStr)&interActive THEN
    replyVal:=0;
    ReadLn(buffer,len);
  END;
END NextLine;

PROCEDURE MyRead(VAR ch: CHAR);
BEGIN
 ch:=buffer[scanReadPos]; INC(scanReadPos);
 IF ch=0C THEN ch:=ASCII.eol END;
 IF (ch=ASCII.eol)OR(ch=ASCII.eof) THEN scanReadPos:=0 END;
END MyRead;

(* holt von Arguments oder interaktiv *)
(* FALSE: optionError *)
PROCEDURE FetchName():BOOLEAN;
VAR ok,opt:BOOLEAN; ch:CHAR; firstPart:BOOLEAN;
BEGIN
  ok:=TRUE;
  REPEAT
    opt:=FALSE;
    IF interActive THEN
      (* In Kick 2.0 die neue Funktion LockToName ausnutzen!! *)
      WriteString(inMsg^); Flush;
    END;
    IF scanReadPos=0 THEN NextLine; firstPart:=TRUE
    ELSE firstPart:=FALSE
    END;
    IF (stStat=argStr)&(ActArg>0) THEN (* kein Double-Scan, lscht "" *)
      Copy(fName,buffer);
      fNameLen:=Length(fName);
    ELSE
      IF ScanString(MyRead,fName,fNameLen,ch) THEN END;(* was da *)
    END;
    IF (fName[0]='-')OR(fName[0]='+')OR(fName[0]='?') THEN
      ok:=OptProc(fName,fNameLen);
      opt:=TRUE;
    END; (* -q mu der erste sein! *)
    IF (fNameLen>0)&verbose THEN
      IF ~interActive THEN
        WriteString(inMsg^);
      END;
      IF ~interActive OR ~firstPart THEN
        FormatS("%s\n",fName);
      END;
    END;
  UNTIL ~ok OR ~opt;
  RETURN ok;
END FetchName;

BEGIN
  ASSEMBLE(
	MOVE.L	thisTask(A4),A0
	MOVE.L	DosD.Process.currentDir(A0),startCD(A4)
  END);
  myRealCD:=DosL.DupLock(startCD);
  myCD:=myRealCD;
  Args:=NumArgs();
  interActive:=FALSE;
  verbose:=TRUE;
  (* ActArg:=0; *)
  (* OptProc:=NIL; *)
  (* OptFile:=NIL; *)
CLOSE
  SETREG(0,DosL.CurrentDir(startCD));
  IF myRealCD#NIL THEN DosL.UnLock(myRealCD); myRealCD:=NIL END;
END ArgHandler.
