IMPLEMENTATION MODULE FullArgHandler;
(*$ LargeVars:=FALSE LongAlign:=FALSE StackChk:=FALSE StackParms:=FALSE
    NilChk:=FALSE Volatile:=FALSE RangeChk:=FALSE OverflowChk:=FALSE *)
(* 22.9.90/bp Jetzt reicht's mir schon wieder! *)
(* Untersttzt ARexx, editor-Msgs *)

FROM SYSTEM	IMPORT	ADDRESS,ADR,SETREG,LONGSET,ASSEMBLE,CAST;
FROM Arts	IMPORT	oldCurrentDir,thisTask,Assert,BreakPoint,returnVal,
			Requester,programName,dosCmdBuf,StrPtr,Terminate,
			wbStarted;
FROM ASCII	IMPORT	eof,eol,nul;
FROM AMScan	IMPORT	ScanString;
FROM Arguments	IMPORT	NumArgs, GetArg, GetLock;
FROM String	IMPORT	Length,Copy,FirstPos,first;
IMPORT DosL;
FROM DosD	IMPORT	read,FileHandlePtr,FileLockPtr,ProcessPtr,Process,
			StandardPacketPtr,sharedLock,readOnly,waitChar;
FROM DosL	IMPORT	Examine,Read,Open,Close,IsInteractive;
FROM ExecD	IMPORT	MsgPortPtr,Message,MessagePtr,NodeType,MsgPortAction,
			NodePtr;
FROM ExecL	IMPORT	Forbid,GetMsg,Permit,PutMsg,ReplyMsg,Wait,
			WaitPort,AllocSignal,FreeSignal,
			AddPort,RemPort,FindTask;
FROM Heap	IMPORT	Allocate,Deallocate;
FROM RexxD	IMPORT	RexxMsgPtr,Command;
(* Terminal auch fr valid cis wichtig!!! *)
FROM Terminal	IMPORT	WriteString,FormatS, ReadLn, Format, WriteHex,
			WriteLn,Flush;
FROM ReplyVals	IMPORT	rcIllegal,rcAbort;
FROM M2Amiga	IMPORT	Exists,ExistsResult;

CONST
 errNoMem= "Nicht gengend Speicher";
 errNoStdin="Ungltiger Eingabestrom";

TYPE
 CharPtr=POINTER TO CHAR;
 Str100=ARRAY[0..99] OF CHAR;
 StringPtr=POINTER TO ARRAY [0..255] OF CHAR;
 (* All these types must be equal to the declarations in the editor! *)
 LinePtr=POINTER TO Line;
 Line=RECORD
  fp,bp: LinePtr;
  size,used: INTEGER;
  text: ARRAY [0..511] OF CHAR
 END;
 EditMsg=RECORD
  msg: Message;
  line: LinePtr;
  currentDirectory: FileLockPtr;
  fileName: StringPtr;
 END;
 EditMsgPtr=POINTER TO EditMsg;

CONST
  MaxStrLen=255;
TYPE
  StringStatus=(fileStr,argStr,interStr);

VAR
  stStat: StringStatus;
  buffer:ARRAY[0..MaxStrLen] OF CHAR;
  scanReadPos:INTEGER;

  ch:CHAR;
  reading: BOOLEAN;
  actionLen:INTEGER;
  nextOut: INTEGER;

  Args,ActArg:INTEGER;
(*$ LongAlign:=TRUE *)
  input: FileHandlePtr;
  lastLine,currLine: LinePtr;
  hostPort:MsgPortPtr;
  hostMsg: RECORD CASE :INTEGER OF
            | 0: rm: RexxMsgPtr;
            | 1: em: EditMsgPtr;
            | 2: dm: StandardPacketPtr;
            END;
          END;
  dosPacket: StandardPacketPtr;
  actionString: StringPtr;
  OptProc: OptionProc;
  inMsg: POINTER TO ARRAY[0..79] OF CHAR;
  OptFile,SecFile: ADDRESS;
  myCDName,backupCDName:Str100;
  startCD,myRealCD,backupCD,foreignDir:FileLockPtr;
  rexxReply:LONGINT;
(*$ POP LongAlign *)

(*
PROCEDURE Show;
VAR rec:RECORD scd,mcd,rcd,bcd,ccd,ocd:FileLockPtr END;
   p:ProcessPtr;
BEGIN
  p:=thisTask;
  rec.ocd:=oldCurrentDir;
  rec.ccd:=p^.currentDir;
  rec.scd:=startCD;
  rec.mcd:=myCD;
  rec.rcd:=myRealCD;
  rec.bcd:=backupCD;
  Format("\nst:%08lx my:%08lx re:%08lx ba:%08lx cu:%08lx oc:%08lx\n",ADR(rec));
END Show;
*)

PROCEDURE CreatePort(portName: ADDRESS; size:INTEGER): ADDRESS;
VAR
  port: MsgPortPtr;
  sig: INTEGER;
BEGIN
  sig:=AllocSignal(-1);
  IF sig>=0 THEN
    Allocate(port,size);
    IF port#NIL THEN
      WITH port^ DO
        node.name:=portName;
        (*node.pri:=0;*)
        node.type:=msgPort;
        flags:=signal;
        sigTask:=FindTask(NIL);
        sigBit:=sig;
      END;
      AddPort(port);
      RETURN port
    ELSE
      FreeSignal(sig)
    END
  END;
  RETURN NIL
END CreatePort;

PROCEDURE DeletePort(msgPort: MsgPortPtr);
BEGIN
  RemPort(msgPort);
  WITH msgPort^ DO
    node.type:=CAST(NodeType,255);
    msgList.head:=CAST(NodePtr,-1);
    FreeSignal(sigBit);
    Deallocate(msgPort)
  END
END DeletePort;

(* p wird aufgerufen, wenn ein String mit '+' oder '-' oder '?' beginnt. *)
PROCEDURE InitHandler(p:OptionProc; portSize:INTEGER;
		rexxStr,portName,msg,firstName,secName:ADDRESS):ADDRESS;
BEGIN
  actionString:=rexxStr;
  actionLen:=Length(actionString^);
  OptProc:=p;
  inMsg:=msg;
  OptFile:=firstName;
  SecFile:=secName;

  IF ~wbStarted & (CAST(StrPtr,dosCmdBuf)^[0]="?") THEN
    IF OptProc("?",1) THEN END;
    Terminate;
  END;

  (* hostPort:=NIL; hostMsg.rm:=NIL *)
  hostPort:=CreatePort(portName,portSize);
  Assert(hostPort#NIL,ADR(errNoMem));

  Allocate(dosPacket,SIZE(dosPacket^));
  Assert(dosPacket#NIL,ADR(errNoMem));

  Assert(input#NIL,ADR(errNoStdin));
  (*reading:=FALSE;*)
  RETURN hostPort;
END InitHandler;

PROCEDURE Compare(len{0}:INTEGER; what{8},buff{9}:CharPtr):BOOLEAN;
VAR pos{1}:INTEGER;
BEGIN
  pos:=0;
  WHILE (what^#nul)&(pos<len) DO
    IF CAP(buff^)#what^ THEN RETURN FALSE END;
    INC(what); INC(buff); INC(pos);
  END;
  RETURN TRUE
END Compare;

PROCEDURE IsRexx():BOOLEAN;
BEGIN
  RETURN Compare(99,ADR("REXX"),hostMsg.rm^.node.node.name)
	 & (hostMsg.rm^.action.command=comm)
END IsRexx;

PROCEDURE ReplyHost;
BEGIN
  IF hostMsg.rm#NIL THEN
    IF hostMsg.dm=dosPacket THEN
      reading:=FALSE;
    ELSE
      IF IsRexx() THEN
        hostMsg.rm^.result1:=rexxReply;
      END;
      ReplyMsg(hostMsg.rm);
    END;
    hostMsg.rm:=NIL;
  END;
END ReplyHost;

PROCEDURE SetReply(val{0}:LONGINT);
BEGIN
  IF val>rexxReply THEN rexxReply:=val END;
  IF val>returnVal THEN returnVal:=val END;
END SetReply;

PROCEDURE SendWaitRequest();
BEGIN
 Flush;
 WITH dosPacket^ DO
  msg.node.name:=ADR(pkt);
  pkt.link:=ADR(dosPacket^.msg);
  pkt.port:=hostPort;
  pkt.type:=waitChar;
  pkt.arg1:=100000;
 END;
 Assert(input^.type#NIL,ADR(errNoStdin));
 PutMsg(input^.type,ADR(dosPacket^.msg));
 reading:=TRUE;
END SendWaitRequest;

(* setzt buffer, source, foreignDir *)
PROCEDURE GetArgString;
CONST DOSFALSE=0;
VAR
  len:INTEGER;
  sp: POINTER TO ARRAY [0..255] OF CHAR;
  ch:CHAR;
BEGIN
  foreignDir:=NIL;
  source:=keyboard;
  ReplyHost;

  IF ~IsInteractive(input) THEN
    ReadLn(buffer,len);
    RETURN;
  END;

  LOOP
    IF ~reading THEN
      SendWaitRequest();
    END;
    rexxReply:=0;
    WaitPort(hostPort);
    hostMsg.rm:=GetMsg(hostPort);
    IF hostMsg.rm#NIL THEN
      IF hostMsg.dm=dosPacket THEN
        IF (hostMsg.dm^.pkt.res1#DOSFALSE) THEN
          ReadLn(buffer,len);
          ReplyHost;
          RETURN;
        END;
        ReplyHost;
      ELSIF IsRexx() THEN
        (* Was ist, wenn nach Start des Progs Rexx doch da ist? *)
        source:=arexx;
        sp:=hostMsg.rm^.args[0];
        Copy(buffer,sp^);
        IF Compare(99,ADR("QUIT"),hostMsg.rm^.args[0]) THEN
          buffer[0]:=nul;
          ReplyHost; (* mit 0=ok *)
          RETURN;
        ELSIF Compare(actionLen,CAST(CharPtr,actionString),hostMsg.rm^.args[0]) THEN
          scanReadPos:=actionLen;
          RETURN;
        ELSE
          rexxReply:=rcIllegal;
          ReplyHost; (* ILLEGAL COMMAND ????*)
        END;
      ELSE
        IF Compare(99,ADR("M2EMACS"),hostMsg.em^.msg.node.name) THEN
        (* editor *)
	  WITH hostMsg.em^ DO
	    lastLine:=line;
	    currLine:=line^.fp;
	    nextOut:=0;
	    foreignDir:=currentDirectory;
	    Copy(buffer,fileName^);
	  END;
	  source:=editor;
	  RETURN;
	ELSE (* was ist das? *)
	  IF Requester( programName,
			ADR("got illegal message"),
			NIL,
			ADR("ok")) THEN
	  END;
	  ReplyHost;
	END;
      END; (* arexx oder edit *)
    END; (* hostMsg#NIL *)
  END; (* LOOP *)
END GetArgString;

PROCEDURE GetTextChar(VAR ch: CHAR);
BEGIN
  WITH currLine^ DO
    IF nextOut=used THEN
      nextOut:=0;
      currLine:=currLine^.fp;
      IF currLine=lastLine THEN
        ch:=nul
      ELSE
        ch:=eol
      END
    ELSE
      ch:=text[nextOut]; INC(nextOut)
    END;
  END
END GetTextChar;

(* liest in buffer[] *)
(* wenn ~interActive, dann nix lesen! *)
PROCEDURE NextLine;
VAR gotFile:BOOLEAN; ch:CHAR; f:FileHandlePtr; len,high:INTEGER;
BEGIN
  myCD:=myRealCD;
  len:=0;
  buffer[0]:=nul;
  high:=MaxStrLen;
  IF stStat=fileStr THEN
    f:=Open(OptFile,readOnly);
    IF f#NIL THEN
      WHILE (len<high)
	   &(Read(f,ADR(ch),1)>0) (* =1 *)
	   &(ch#eol)
	   &(ch#eof) DO
	buffer[len]:=ch; INC(len);
      END;
      Close(f);
    END;

    f:=Open(SecFile,readOnly);
    IF f#NIL THEN
      IF len>0 THEN buffer[len]:=" "; INC(len); END; (* trennen. falls Zahl *)
      WHILE (len<high)
	   &(Read(f,ADR(ch),1)>0) (* =1 *)
	   &(ch#eol)
	   &(ch#eof) DO
	buffer[len]:=ch; INC(len);
      END;
      Close(f);
    END;
    buffer[len]:=nul;

    INC(stStat); (* args dranhngen! *)
  END;
  IF (len=0)&(stStat=argStr) THEN
    INC(ActArg);
    IF ActArg<=Args THEN
      GetArg(ActArg,buffer,len); (* Weil GetArg CD verndert! *)
      myCD:=GetLock(ActArg);
      IF myCD=NIL THEN myCD:=myRealCD END;
    ELSE
      INC(stStat);
    END;
  END;
  IF (stStat=interStr)&interActive THEN
    GetArgString;
    IF source#keyboard THEN
      Copy(backupCDName,myCDName);
      backupCD:=myRealCD;
      IF source=arexx THEN
        myRealCD:=DosL.DupLock(backupCD);
      ELSE (* editor *)
        myRealCD:=DosL.DupLock(foreignDir);
      END;
    END;
    myCD:=myRealCD;
  END;
  SETREG(0,DosL.CurrentDir(myCD));
END NextLine;

PROCEDURE MyRead(VAR ch: CHAR);
BEGIN
 ch:=buffer[scanReadPos]; INC(scanReadPos);
 IF ch=nul THEN ch:=eol END;
 IF (ch=eol)OR(ch=eof) THEN scanReadPos:=0 END;
END MyRead;

(* holt von Arguments oder interaktiv *)
(* FALSE: optionError *)
PROCEDURE FetchName():BOOLEAN;
VAR ok,opt:BOOLEAN; ch:CHAR; firstPart:BOOLEAN;
BEGIN
  ok:=TRUE;
  REPEAT
    opt:=FALSE;
    IF interActive THEN
      IF (scanReadPos=0)&(backupCD#NIL) THEN (* alten (User) Zustand wieder! *)
        IF myRealCD#NIL THEN DosL.UnLock(myRealCD) END;
        myRealCD:=backupCD;
        backupCD:=NIL;
        Copy(myCDName,backupCDName);
        myCD:=myRealCD;
        SETREG(0,DosL.CurrentDir(myCD));
      END;
      (* In Kick 2.0 die neue Funktion LockToName ausnutzen!! *)
      FormatS(inMsg^,myCDName); Flush;
    END;
    IF scanReadPos=0 THEN
      NextLine; firstPart:=source=keyboard;
      Flush;
    ELSE firstPart:=FALSE
    END;
    IF (stStat=argStr)&(ActArg>0) THEN (* Kein DoubleScan wegen ""! *)
      Copy(fName,buffer);
      fNameLen:=Length(fName);
    ELSE
      IF ScanString(MyRead,fName,fNameLen,ch) THEN END;(* was da *)
    END;
    IF (fName[0]='-')OR(fName[0]='+')OR(fName[0]='?') THEN
      ok:=OptProc(fName,fNameLen);
      opt:=TRUE;
    END; (* -q mu der erste sein! *)
    IF (fNameLen>0)&verbose THEN
      IF ~interActive THEN
        FormatS(inMsg^,myCDName);
      END;
      IF ~interActive OR ~firstPart THEN
        FormatS("%s\n",fName);
      END;
    END;
  UNTIL ~ok OR ~opt;
  RETURN ok;
END FetchName;

(*$ CopyDyn:=FALSE *)
PROCEDURE GotoDir(s:ARRAY OF CHAR):BOOLEAN; (* ""=goHome! *)
VAR dir{10}:FileLockPtr;
BEGIN
  IF s[0]=0C THEN (* goHome *)
    DosL.UnLock(myRealCD);
    myRealCD:=DosL.DupLock(startCD);
    SETREG(0,DosL.CurrentDir(myRealCD));
    myCDName[0]:=0C;
  ELSE
    dir:=NIL;
    SETREG(0,DosL.CurrentDir(myRealCD)); (* oh, ja!!! *)
    IF Exists(s)=dirExists THEN (* ist es dir und kein File? *)
      dir:=DosL.Lock(ADR(s),sharedLock);
    END;
    IF dir=NIL THEN RETURN FALSE END;
    DosL.UnLock(myRealCD);
    myRealCD:=dir;
    SETREG(0,DosL.CurrentDir(dir));
    Copy(myCDName,s);
  END;
  (*GetPath(myRealCD);*)
  myCD:=myRealCD;
  RETURN TRUE;
END GotoDir;

PROCEDURE CleanHost;
VAR empty{7}:BOOLEAN;
BEGIN
  IF hostPort#NIL THEN
    rexxReply:=rcAbort;
    ReplyHost;
    Forbid; (* damit keiner mehr was senden kann *)
    REPEAT
      IF reading THEN WaitPort(hostPort) END;
      hostMsg.rm:=GetMsg(hostPort);
      empty:=hostMsg.rm=NIL;
      ReplyHost;
    UNTIL empty & ~reading;
    DeletePort(hostPort);
    hostPort:=NIL;
    Permit;
  END;
END CleanHost;

BEGIN
(*
  myCDName[0]:=nul;
  foreignDir:=NIL;
  backupCD:=NIL;
  rexxReply:=0;
  interActive:=FALSE;
  ActArg:=0;
  OptProc:=NIL;
  OptFile:=NIL;
*)
  ASSEMBLE(
	MOVE.L	thisTask(A4),A0
	MOVE.L	Process.currentDir(A0),startCD(A4)
	MOVE.L	Process.cis(A0),input(A4)
  END);
  myRealCD:=DosL.DupLock(startCD);
  myCD:=myRealCD;
  Args:=NumArgs();
  verbose:=TRUE;
  source:=keyboard;
CLOSE
  SETREG(0,DosL.CurrentDir(startCD));
  IF myRealCD#NIL THEN DosL.UnLock(myRealCD); myRealCD:=NIL END;
  IF backupCD#NIL THEN DosL.UnLock(backupCD); backupCD:=NIL END;
  CleanHost;
END FullArgHandler.
