IMPLEMENTATION MODULE MkExecute;
(*$ LargeVArs:=FALSE LongAlign:=TRUE StackParms:=FALSE Volatile:=FALSE *)
(*$ StackChk:=FALSE NilChk:=FALSE *)
(* 24.9.90/bp Groe Aufrumung! *)


FROM SYSTEM IMPORT ADDRESS, BPTR, ADR, CAST, ASSEMBLE;

FROM Arts IMPORT
 wbStarted, Assert, thisTask, Error, BreakPoint;

FROM ASCII IMPORT
 eol, nul;

FROM DosD IMPORT
 CommandLineInterfacePtr, ProcessPtr, DosLibraryPtr, ResidentSegment,
 CommandLineInterface, Process;
FROM DosL IMPORT
 LoadSeg, UnLoadSeg, dosBase;

FROM Heap IMPORT
 Allocate, Deallocate;

FROM String IMPORT
 Concat, Length;

FROM Terminal IMPORT
 Write, WriteString, WriteLn;


(*$ DEFINE English:=FALSE *)

CONST
  (* losec secSize upsec *)
    loSecure = 100;
    upSecure = 100; (* mind. 60! *)
    loOffset = loSecure;

 noStackSpace=
(*$ IF English *)
   "m2make: Insufficient Memory!";
(*$ ELSE *)
   "m2make: Nicht gengend Speicher!";
(*$ ENDIF *)

VAR
  stack: ADDRESS;
  process: ProcessPtr;
  artCLI: POINTER TO CommandLineInterface;
  pureStack:LONGINT; (* =2000; damit das Prog selbst alloziert! *)
  hiOffset:LONGINT; (* = loSecure+pureStack;*)


(*$ RangeChk:=FALSE OverflowChk:=FALSE *)

PROCEDURE NewCli(VAR name:LONGINT);
  BEGIN
    Allocate(artCLI,SIZE(CommandLineInterface));
    Assert(artCLI#NIL,ADR(noStackSpace));
    WITH artCLI^ DO
      commandName:=ADR(name); (* Nur diese Dinge benutzt der Startup-Code *)
      defaultStack:=pureStack DIV 4;
    END;
    process^.cli:=BPTR(artCLI);
 END NewCli;


PROCEDURE DelCli;
  BEGIN
    process^.cli:=NIL;
    Deallocate(artCLI);
  END DelCli;


PROCEDURE InitExec(progStack:LONGINT);
  BEGIN
    pureStack:=progStack;
    hiOffset:=loSecure+pureStack;
    Allocate(stack,loSecure+upSecure+pureStack);
    Assert(stack#NIL,ADR(noStackSpace));
    outString[0]:=0C;
  END InitExec;


TYPE
  MyResidentPtr=BPOINTER TO MyResident;
  MyResident=RECORD
    next:MyResidentPtr;
    usecount:LONGINT;
    segment:BPTR;
    name: LONGINT;
  END;

PROCEDURE SearchResidentList(resProgName: LONGINT; VAR res: MyResidentPtr): BPTR;
VAR
  entry: MyResidentPtr;
BEGIN
  entry:=CAST(BPTR,dosBase^.root^.info^.netHand);
  WHILE entry#NIL DO
    WITH entry^ DO
      IF (name=resProgName)&(usecount>=0) THEN
        res:=entry;
        RETURN segment
      ELSE
        entry:=next
      END
    END
  END;
  res:=NIL;
  RETURN NIL
END SearchResidentList;

(*$ CopyDyn:=FALSE *)
PROCEDURE Call(prog: ARRAY OF CHAR; name: LONGINT): LONGINT;
VAR
  loStack, hiStack, oldLow, oldUp: LONGINT;
  seg: BPTR;
  odefault: LONGINT;
  sp: ADDRESS;
  result: LONGINT;
  res: MyResidentPtr;
  argLen: INTEGER;
BEGIN
  Assert(stack#NIL,ADR("M2ME: BUG!!!"));
  Concat(outString,eol);
  outString[2047]:=eol; (* AUF JEDEN FALL ein eol am Ende! *)
  WriteLn;
  WriteString(prog); Write(' ');WriteString(outString);
  WriteLn;
  result:=-1;

  seg:=SearchResidentList(name, res);
  IF seg=NIL THEN
    seg:=LoadSeg(ADR(prog))
  ELSE
    INC(res^.usecount)
  END;
  IF seg#NIL THEN
    loStack:=stack+loOffset;
    hiStack:=stack+hiOffset;
    IF wbStarted THEN
      NewCli(name);
   (*
     erzeuge eine Art CLI Struktur !!! Kamikaze-Typen!!!
     nicht ein Art, sondern eine richtige!! Wenn schon, denn schon /bp
     process^.cli:=CAST(CommandLineInterfacePtr,201) falsch! Oh Gott!
   *)
    ELSE
      WITH process^.cli^ DO
        odefault:=defaultStack;
        defaultStack:=pureStack DIV 4;
      END;
    END;
    argLen:=Length(outString);
    WITH process^ DO
      oldLow:=task.spLower;
      oldUp:=task.spUpper;
      task.spLower:=loStack;
      task.spUpper:=hiStack;
    END;
    ASSEMBLE(
	MOVE.L	A7,sp(A5)
	MOVE.L	hiStack(A5),A7
	LEA	4*11(A7),A7 (* register darber! *)
	MOVEM.L	D2-D7/A2-A6,-(A7)
	MOVE.L	pureStack(A4),-(A7)
	MOVE.L	argLen(A5),D0
	LEA	outString(A4),A0
	MOVE.L	seg(A5),A1
	ADDA.L	A1,A1
	ADDA.L	A1,A1 (* bptr seglist *)
	JSR	4(A1)
	ADDQ.L	#4,A7 (* para-abbau *)
	MOVEM.L	(A7)+,D2-D7/A2-A6
	MOVE.L	sp(A5),A7
	MOVE.L	D0,result(A5)
    END);
    WITH process^ DO
      task.spLower:=oldLow;
      task.spUpper:=oldUp;
    END;
    IF wbStarted THEN
      DelCli;
    ELSE
      process^.cli^.defaultStack:=odefault;
    END;
    IF res=NIL THEN
      UnLoadSeg(seg)
    ELSE
      DEC(res^.usecount)
    END
  ELSE
    WriteString(prog);
    WriteString(": Programm kann nicht geladen werden\n");
  END;
  Deallocate(stack);
  RETURN result
END Call;

BEGIN
  process:=thisTask;
  (* stack:=NIL; *)
END MkExecute.mod
